unit unitWeb;

interface

uses SysUtils, Classes, Windows, WideStrUtils, IdHTTP, WinInet, IdSSLOpenSSL
  , IdGlobal, HTTPApp;

  function isUTF8(pstr: PAnsiChar): Boolean; stdcall;
  function AnsiToUTF8(pstr: PAnsiChar): PAnsiChar; stdcall;
  function UTF8ToAnsi(pstr: PAnsiChar): PAnsiChar; stdcall;
  function encodeHTTP(pstr: PAnsiChar): PAnsiChar; stdcall;
  function decodeHTTP(pstr: PAnsiChar): PAnsiChar; stdcall;
  function post4HTTP(url: PAnsiChar; readTimeOut, connectTimeOut, typeSSL: Integer; contentType, customHeaders, parameters: PAnsiChar): PAnsiChar stdcall;
  function get4HTTP(url: PAnsiChar; readTimeOut, connectTimeOut: Integer; contentType, customHeaders, parameters: PAnsiChar): PAnsiChar stdcall;

implementation

var
  tmpRawString: RawByteString;  //ӽû
  tmpRawString4Convert: RawByteString;  //ȯ ӽû



//UTF8 ڵ ˻
function isUTF8(pstr: PAnsiChar): Boolean; stdcall;
begin
  result := isUTF8String(RawByteString(pstr));
end;


function AnsiToUTF8(pstr: PAnsiChar): PAnsiChar; stdcall;
begin
  tmpRawString4Convert := System.AnsiToUtf8(string(pstr));
  result := PAnsiChar(tmpRawString4Convert);
end;

function UTF8ToAnsi(pstr: PAnsiChar): PAnsiChar; stdcall;
var
  str: ansistring;
begin
  str := System.Utf8ToAnsi(pstr);       //Utf8ToString
  if length(str) > 0 then begin
    setLength(tmpRawString4Convert, length(str));
    strLCopy(PAnsiChar(tmpRawString4Convert), PAnsiChar(str), length(str));
  end;
  result := PAnsiChar(tmpRawString4Convert);
end;


function encodeHTTP(pstr: PAnsiChar): PAnsiChar; stdcall;
var
  str: ansistring;
begin
  tmpRawString4Convert := HTTPEncode(string(pstr));
  result := PAnsiChar(tmpRawString4Convert);
end;


function decodeHTTP(pstr: PAnsiChar): PAnsiChar; stdcall;
var
  str: ansistring;
begin
  tmpRawString4Convert := HTTPDecode(string(pstr));
  result := PAnsiChar(tmpRawString4Convert);
end;


(*
  Post HTTPϰ  ޱ
  url:  ּ
  readTimeOut   : б Ÿ ð(: ms)
  connectTimeOut: Ӵ Ÿ ð(: ms)
  typeSSL       : SSL  =-1     0 5 Է  TIdSSLVersion = (sslvSSLv2, sslvSSLv23, sslvSSLv3, sslvTLSv1,sslvTLSv1_1,sslvTLSv1_2)
  contentType   : html contentType Է
  customHeaders :  ʿ  Է
  parameters    : ڰ   Է

  result        :  ,  (  , ݵ freeMemoryȣ )

  뿹: txtResponse := post4HTTP('http://hwangji.kr', 0, 0, -1, 'application/x-www-form-urlencoded', '', '');
*)
function post4HTTP(url: PAnsiChar; readTimeOut, connectTimeOut, typeSSL: Integer; contentType, customHeaders, parameters: PAnsiChar): PAnsiChar stdcall;
var
  lHTTP: TIdHTTP;
  lIOHandler: TIdSSLIOHandlerSocketOpenSSL;
  lParamList, response: TStringStream;
begin
  lParamList := TStringStream.Create;
  response := TStringStream.Create;
  lHTTP := TIdHTTP.Create;
  lHTTP.ReadTimeout := readTimeOut;
  lHTTP.ConnectTimeout := connectTimeOut;
  if typeSSL > -1 then
    lIOHandler := TIdSSLIOHandlerSocketOpenSSL.Create(lHTTP);
  try
    if typeSSL > -1 then begin
      lIOHandler.SSLOptions.Method := TIdSSLVersion(typeSSL);
      lHTTP.IOHandler := lIOHandler;
    end;
    lHTTP.HandleRedirects := true;
    lHTTP.Request.ContentType := string(contentType);
    lHTTP.Request.CustomHeaders.Text := string(customHeaders);

    lParamList.WriteString(string(parameters));
    lHTTP.Post(String(url), lParamList, response);
    if (response.Size > 0) then begin
      setLength(tmpRawString, response.Size);
      strLCopy(PAnsiChar(tmpRawString), PAnsiChar(response.Memory), response.Size);
    end;
    result := PAnsiChar(tmpRawString);
  except on E: Exception do begin            //final ߴٰ Ȥ  ܷ ׳ exceptó
      tmpRawString := e.Message;
      result := PAnsiChar(tmpRawString);
    end;
  end;
    FreeAndNil(Response);
    FreeAndNil(lParamList);
    if typeSSL > -1 then
      FreeAndNil(lIOHandler);
    FreeAndNil(lHTTP);
end;




(*
  Get HTTPϰ  ޱ
  url:  ּ
  readTimeOut   : б Ÿ ð(: ms)
  connectTimeOut: Ӵ Ÿ ð(: ms)
  contentType   : html contentType Է
  customHeaders :  ʿ  Է
  parameters    : ڰ   Է

  result        :  ,  (  , ݵ freeMemoryȣ )

  뿹: txtResponse := post4HTTP('http://hwangji.kr', 0, 0, 'text/html; charset=utf-8', '', '');
*)
function get4HTTP(url: PAnsiChar; readTimeOut, connectTimeOut: Integer; contentType, customHeaders, parameters: PAnsiChar): PAnsiChar stdcall;
var
  lHTTP: TIdHTTP;
  response: TStringStream;
  urlWithParam: String;
begin
  response := TStringStream.Create;
  lHTTP := TIdHTTP.Create;
  lHTTP.ReadTimeout := readTimeOut;
  lHTTP.ConnectTimeout := connectTimeOut;
  try
    lHTTP.HandleRedirects := true;
    lHTTP.Request.ContentType := string(contentType);
    lHTTP.Request.CustomHeaders.Text := string(customHeaders);

    urlWithParam := String(url) + '?' + string(parameters);
    lHTTP.Get(urlWithParam, response);
    if (response.Size > 0) then begin
      setLength(tmpRawString, response.Size);
      strLCopy(PAnsiChar(tmpRawString), PAnsiChar(response.Memory), response.Size);
    end;
    result := PAnsiChar(tmpRawString);
  except on E: Exception do begin            //final ߴٰ Ȥ  ܷ ׳ exceptó
      tmpRawString := e.Message;
      result := PAnsiChar(tmpRawString);
    end;
  end;
    FreeAndNil(Response);
    FreeAndNil(lHTTP);
end;


end.
