unit unitWebBrowser;

interface

uses
  OleCtrls, SHDocVw, Windows, Messages, SysUtils, ActiveX;

type
  TNHWebBrowser = class(TWebBrowser)
  public
    function execute(commandID: integer): string;
  end;

  function CreateWebBrowser(PHdl: THandle): longint; stdcall;
  procedure FreeWebBrowser(objAddr: longint); stdcall;
  procedure NavigateWebBrowser(objAddr: longint; URL: PAnsiChar); stdcall;
  function ExecuteWebBrowser(objAddr: longint; commandID: integer): pansichar; stdcall;

implementation

var
  tmpRawString: RawByteString;  //ӽû

  function TNHWebBrowser.execute(commandID: integer): string;
  var
    rt: TRect;
    aParam, bParam: olevariant;
  begin
    result := '';
    case commandID of
        OLECMDID_OPEN: ExecWB(OLECMDID_OPEN, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_NEW: ExecWB(OLECMDID_NEW, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SAVE: ExecWB(OLECMDID_SAVE, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SAVEAS: ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SAVECOPYAS: ExecWB(OLECMDID_SAVECOPYAS, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_PRINT: ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_PRINTPREVIEW: ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_PAGESETUP: ExecWB(OLECMDID_PAGESETUP, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SPELL: ExecWB(OLECMDID_SPELL, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_PROPERTIES: ExecWB(OLECMDID_PROPERTIES, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_CUT: ExecWB(OLECMDID_CUT, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_COPY: ExecWB(OLECMDID_COPY, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_PASTE: ExecWB(OLECMDID_PASTE, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_PASTESPECIAL: ExecWB(OLECMDID_PASTESPECIAL, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_UNDO: ExecWB(OLECMDID_UNDO, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_REDO: ExecWB(OLECMDID_REDO, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SELECTALL: ExecWB(OLECMDID_SELECTALL, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_CLEARSELECTION: ExecWB(OLECMDID_CLEARSELECTION, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_ZOOM: ExecWB(OLECMDID_ZOOM, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_GETZOOMRANGE: ExecWB(OLECMDID_GETZOOMRANGE, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_UPDATECOMMANDS: ExecWB(OLECMDID_UPDATECOMMANDS, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_REFRESH: ExecWB(OLECMDID_REFRESH, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_STOP: ExecWB(OLECMDID_STOP, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_HIDETOOLBARS: ExecWB(OLECMDID_HIDETOOLBARS, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SETPROGRESSMAX: ExecWB(OLECMDID_SETPROGRESSMAX, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SETPROGRESSPOS: ExecWB(OLECMDID_SETPROGRESSPOS, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SETPROGRESSTEXT: ExecWB(OLECMDID_SETPROGRESSTEXT, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SETTITLE: ExecWB(OLECMDID_SETTITLE, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_SETDOWNLOADSTATE: ExecWB(OLECMDID_SETDOWNLOADSTATE, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        OLECMDID_STOPDOWNLOAD: ExecWB(OLECMDID_STOPDOWNLOAD, OLECMDEXECOPT_DODEFAULT, aParam, bParam);
        1000: GoBack;
        1001: GoForward;
        1002: GOHome;
        1003: GoSearch;    //HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Main Search Page ϵ 
        1004: Stop;
        1005: Refresh;
        1100: begin
                Windows.GetClientRect(ParentWindow, rt);
                SetBounds(0,0,rt.Right - rt.Left, rt.Bottom - rt.Top);
//                PostMessage(Handle, WM_SIZE, SIZE_MAXIMIZED, 0);
        end;
        2000: oleobject.Document.body.Scroll := 'yes';
        2001: oleobject.Document.body.Scroll := 'no';
        2002: result := oleobject.Document.documentelement.outerHTML;
        2003: result := oleobject.Document.documentelement.outerText;
    end;
  end;


  function CreateWebBrowser(PHdl: THandle): longint; stdcall;
  var
    WB: TNHWebBrowser;
    bnd: TRect;
  begin
    WB := TNHWebBrowser.Create(nil);
    try
      WB.Silent := true;
      GetClientRect(PHdl, bnd);
      WB.ParentWindow := PHdl;
      WB.SetBounds(0,0,bnd.Right - bnd.Left, bnd.Bottom - bnd.Top);
      result := longint(WB);
    except
      WB.Free;
      result := 0;
    end;
  end;


  procedure FreeWebBrowser(objAddr: longint); stdcall;
  begin
      FreeAndNil(TNHWebBrowser(Pointer(objAddr)));
  end;

  procedure NavigateWebBrowser(objAddr: longint; URL: PAnsiChar); stdcall;
  begin
    TNHWebBrowser(Pointer(objAddr)).Navigate(URL);
  end;

  function ExecuteWebBrowser(objAddr: longint; commandID: integer): pansichar; stdcall;
  begin
    tmpRawString := TNHWebBrowser(Pointer(objAddr)).execute(commandID);
    result := PAnsiChar(tmpRawString);
  end;

var
  GSaved8087CW: Word;
  NeedToUnitialize: Boolean;

initialization
  GSaved8087CW := Default8087CW;
  Set8087CW($133F);
  NeedToUnitialize := Succeeded(OleInitialize(nil));

finalization
  Set8087CW(GSaved8087CW);
  if NeedToUnitialize then
  try
    OleUninitialize;
  except
  end;

end.
